#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, void **argv)
{
        int sock;
        struct sockaddr_in serv_addr;
        char msg[30];
        int str_len;

        if(argc != 3)
        {
                printf("Usage : %s <IP> <PORT>\n", argv[0]);
                exit(1);
        }

        sock = socket(PF_INET, SOCK_STREAM, 0);

        if(sock == -1)
        {
                printf("socket() error\n");
                exit(1);
        }

        memset(&serv_addr, 0, sizeof(serv_addr));
        serv_addr.sin_family = AF_INET;
        serv_addr.sin_addr.s_addr = inet_addr(argv[1]);
        serv_addr.sin_port = htons(atoi(argv[2]));

        if(connect(sock, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) == -1                                              )
        {
                printf("connect() error\n");
                exit(1);
        }

        str_len = read(sock, msg, sizeof(msg) - 1);

        if(str_len == -1)
        {
                printf("read error\n");
                exit(1);
        }

        printf("Msg from server %s\n", msg);

        close(sock);

        return 0;
}
