#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>

void error_handling(char *msg);

int main(int argc, void **argv)
{
        int serv_socket;
        int clnt_socket;

        struct sockaddr_in serv_addr;
        struct sockaddr_in clnt_addr;

        char message[] = "hello world!";

        if(argc != 2)
        {
                printf("Usage : %s <port>\n", argv[0]);
        }

        if((serv_socket = socket(PF_INET, SOCK_STREAM, 0)) == -1)
                error_handling("socket() error");

        memset(&serv_addr, 0, sizeof(serv_addr));
        serv_addr.sin_family = AF_INET;
        serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
        serv_addr.sin_port = htons(atoi(argv[1]));

        if(bind(serv_socket, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) == -1)
                error_handling("bind() error");

        if(listen(serv_socket, 15) == -1)
                error_handling("listen() error");

        socklen_t clnt_addr_size;

        clnt_addr_size = sizeof(clnt_addr);
        clnt_socket = accept(serv_socket, (struct sockaddr*) &clnt_addr, &clnt_addr_size);
        if(clnt_socket == -1)
                error_handling("accept() error");

        write(clnt_socket, message, sizeof(message));
        close(clnt_socket);
        close(serv_socket);

        return 0;
}

void error_handling(char *msg)
{
        fputs(msg, stderr);
        fputc('\n', stderr);
        exit(1);
}
